--  cockpit atlantis_ext description

-- external views: 20m from the center and 20° downwards
local degree = 180/math.pi
local dist = 20  --distance au centre
local angle = -20
local y = -dist * math.sin(angle/degree)  -- displacement height
local proj = -dist * math.cos(angle/degree) -- max lateral displacement

------------------------------------------------------------------
atlantis_ext = {
    panelratio=8/5;  	--  cockpit picture width / picture height
    vfov=43; 		--  default vertical field of view (FOV) in degrees of the cockpit
	firstpanel = 1;
	frontpanel = 4;
    rearpanel = 8; 		--  

	orientation = { -- orientation of each panel
		{0,0},	 	--1 left pilot view
		{0,0}, 		--2 right pilot view
		{0,0},		--3 complete dashboard
		{0,-20},	--4 forward view (from the shuttle's tail)
		{45,-20},	--5
		{90,-20},	--6
		{135,-20},	--7
		{180,-20},	--8 backward view (from the suttles's nose)
		{225,-20},	--9
		{270,-20},	--10
		{315,-20},	--1
	},

	displacement = { -- coord x, y , z in meters (mathematical functions are not required ;-) 
		[4] = {0, y, proj},
		[5] = {proj*math.sin(45/degree), y, proj* math.cos(45/degree)},
		[6] = {proj, y, 0},
		[7] = {proj*math.sin(135/degree), y, proj* math.cos(135/degree)},
		[8] = {0, y, -proj},
		[9] = {proj*math.sin(225/degree), y, proj* math.cos(225/degree)},
		[10] = {-proj, y, 0},
		[11] = {proj*math.sin(315/degree), y, proj* math.cos(315/degree)},
	},

	viewpath =
	{ -- panel links for the arrows {left,right,up,down,center}
	  -- the center link is optional
		{0,2,4,3,8}, --1
		{1,0,4,3,8}, --2
		{10,6,1,0,8}, --3
		{11,5,0,1}, --4
		{4,6,0,2}, --5
		{5,7,0,2}, --6
		{6,8,0,2}, --7
		{7,9,0,1,4}, --8
		{8,10,0,1}, --9
		{9,11,0,1}, --10
		{10,4,0,1}, --11
	},
}

