-- beepilog cockpit description

-- Characteristics of your picture if you want one
local pictureName = "photo.png"  -- png or jpg file
local pictureWidth, pictureHeight = 400, 400 -- original size of the picture photo (Bubug)


beepilot = {
    panelratio=8/5;  	--  cockpit picture width / picture height
    vfov=50; 		--  default vertical field of view (FOV) in degrees of the cockpit
    rearpanel = 8; 		--  "beepilot-8.png" is the rear view
	
	image = {
		--[7] = {"photo.png", 0.428, 0.793, 0.0648, 0.103}, -- just an example. Redefined later
	},
	orientation = { -- orientation of each panel
		{0,0},	 	-- #1 front view 
		{0,-25, 35},  --#2 command panel FOV = 35 degrees (default is 50)
		{50,-17},	-- #3 right view (17 degrees down)
		{80,0},		-- #4	right side view
		{280,0},	-- #5	left rear view
		{310,-17},	-- #6	left view
		{0,30},		-- #7 front up view
		{180,0}, 	-- #8 monitor view showing backward
	},
	
	viewpath = 
	{ -- panel link for the arrows {left,right,up,down}
		{6,3,7,2},
		{6,3,1,8},	
		{1,4,7,2},
		{3,8,0,0},
		{8,6,0,0},	
		{5,1,7,2},
		{6,3,0,1},
		{4,5,2,0},
	},
}

----------------------------------------------
-- centering the image on its frame
local X, Y, W, H
X = 385/900;   Y = 476/600  -- initial position on the cockpit windshield (900 x 600)
local r = pictureWidth / pictureHeight

if r > 1.258 then
	W = 73/900
	H = 73/r /600
	Y = Y + ((62-73/r)/2)/600
	
else
	H = 62/600
	W = 62*r /900
	X = X + ((73-62*r)/2)/900
end
beepilot.image[7] = {pictureName, X, Y, W, H}