local AV = celestia:newvector(0,0,-1) -- forward
local UP = celestia:newvector(0,1,0)
local GA = celestia:newvector(1,0,0)
local km = 9460730.4725808
local StarSystem, model3D
local reactivity
local dx, dy, dz, defx, defy, defz
local cockpitspeed
local standardmode = true


local frame, positionframe, orientationframe
local oldorient, oldposition, cockpitorient
local moteur, gouv

function suivi_orbit(t)
   local orbit = {};
   orbit.boundingRadius = 1

   StarSystem = t.StarSystem
   model3D = t.Model3D
   dx = t.dx /1000
   dy = t.dy /1000
   dz = t.dz /1000
   defx, defy, defz = dx, dy, dz
   
   reactivity = math.min(math.max(t.reactivity, 0.01),1)
   
   function orbit:position(tjd)
		moteur = moteur or celestia:find("Sol/"..model3D.."_translation_gear") 
		local centre = celestia:find(StarSystem)
		frame = celestia:newframe("ecliptic",centre)
		local obs = celestia:getobserver()
		local obsframe = obs:getframe()
		local obsposition = obs:getposition()
		local orient = obs:getorientation()
		local pos
		if moteur:radius() >= 1 then -- reinit position
			if moteur:radius() == 1 then
				dx, dy, dz = defx, defy, defz
			elseif moteur:radius() == 2 then
				dx, dy, dz = 0, 0, 0
			end
			oldposition, cockpitorient = nil, nil
			moteur:setradius(0.1)
		end
		
		if standardmode  or not oldposition then
			positionframe = obsframe
			pos = obsposition
			local dir = (AV * dz) + (UP *dy) +(GA * dx)
			orient = cockpitorient or orient
			local vdir = orient:transform(dir) * (1/km)
			pos = pos:addvector(vdir) --cockpit position
			
			if oldposition then
				cockpitspeed = positionframe:to(pos) - oldposition
			end
			standardmode = moteur:visible()
		end	
		-- cel://Follow/Sol:Earth:ISS/2013-01-29T07:47:30.30321?x=DnwbeS8&y=KuCRfwo&z=mDPrrvj//////////////w&ow=0.693022&ox=0.106942&oy=-0.710666&oz=-0.0569028&select=Sol:Earth:ISS&fov=50&ts=1&ltd=0&p=0&rf=70616979&lm=2178&tsrc=0&ver=3
		if not standardmode then	
			if moteur:visible() then
				pos = positionframe:from(oldposition + cockpitspeed )
				obsposition = obs:getposition()
				orient = cockpitorient or orient
			
				local depli = obsposition:vectorto(pos)
				local imag, real = orient:imag(), orient:real()
				local invrot = celestia:newrotation(-real, imag.x, imag.y, imag.z)
				local depl = invrot:transform(depli)
				dx = depl.x * km
				dy = depl.y * km
				dz = -depl.z * km
			else
				if obsframe:getrefobject():name() == model3D then
					pos = positionframe:from(oldposition + cockpitspeed)
					-- obsposition = positionframe:to(obsposition) + cockpitspeed
					-- obsposition = positionframe:from(obsposition)
					-- obs:setposition(obsposition)
				else
					pos = positionframe:from(oldposition + cockpitspeed)
					obsposition = positionframe:to(obsposition) + cockpitspeed
					obsposition = positionframe:from(obsposition)
					obs:setposition(obsposition)
				end
			end
			standardmode = moteur:visible()		
		end

		oldposition = positionframe:to(pos)
		
		pos = frame:to(pos)
		return pos:getx() * km , -pos:getz() * km, pos:gety() * km
    end

    return orbit
end 

function suivi_attitude(t)
	local attitude = {}
	
	function attitude:orientation(tjd)
		gouv = gouv or celestia:find("Sol/"..model3D.."_rotation_gear")
		local obs=celestia:getobserver()
		local obsframe = obs:getframe()
		local orient = obs:getorientation()
		if gouv:visible() or not cockpitorient then
			orientationframe = obsframe
			if cockpitorient then
				orient=cockpitorient:slerp(orient,reactivity)
			end
			cockpitorient = orient
			local garagetime = celestia:gettime()
			oldorient = orientationframe:to(orient,garagetime)
		else
			cockpitorient = orientationframe:from(oldorient)
		end
		orient = frame:to(cockpitorient)
		local vector = orient:imag()
		local w = orient:real()
		return w, vector.x, vector.y, vector.z
	end

	return attitude
end
